program StepDur;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  windows,
  mmsystem;

procedure NtDelayExecution(Alertable:boolean;Interval:PInt64); stdcall; external 'ntdll.dll';

function tsc: Int64;
var ts: record
 case byte of
  1: (count: Int64);
  2: (b, a: cardinal);
 end;
begin
 asm
  db $F;
  db $31;
  mov [ts.a], edx
  mov [ts.b], eax
 end;
 tsc:=ts.count;
end;

function calibrate_runtime:Int64;
var i:byte; tstsc,tetsc,crtm:Int64;
begin
 tstsc:=tsc;
 crtm:=tsc-tstsc;
 for i:=0 to 9 do
  begin
   tstsc:=tsc;
   crtm:=tsc-tstsc;
   if tetsc<crtm then crtm:=tetsc;
  end;
 calibrate_runtime:=crtm;
end;

function onecycletime:Currency;
var tstsc,tetsc,p:Int64;
begin
 timeBeginPeriod(1);
 sleep(20);
 p:=-100000000;
 tstsc:=tsc;
 NtDelayExecution(false,@p);
 tetsc:=tsc-tstsc;
 timeEndPeriod(1);
 onecycletime:=(10000000000/(tetsc-calibrate_runtime));
end;

var oct:Currency;
begin
 WriteLn('The program will show duration of one step of your processor.');
 WriteLn;
 WriteLn('Expected time of check - 10 seconds. Press any key for start of the test...');
 ReadLn;
 oct:=onecycletime;
 WriteLn('The test is completed. Duration of one processor''s step = '+FloatToStr(oct)+' nanoseconds.');
 WriteLn('Light for this time has time to fly by '+CurrToStr(oct*(299792458/1000000000)*100)+' centimeters :).');
 WriteLn('Press any key for an exit...');
 ReadLn;
end.

// begin_end (C) 2009
